p7q Posted March 20 Posted March 20 I am working on a routine that processes polylines containing arc segments. The function calculates the midpoint of an arc segment and attempts to use the _dimradius command to add a radius dimension. (setq arcData (BulgetoArc p1 p2 bulge)) (setq center (nth 0 arcData)) (setq radius (nth 3 arcData)) (setq intersection (line-intersection p0 p1 p2 p3)) (setq arc (NearestPointToEntity intersection ent)) (command-s "_.dimradius" arc intersection "") However, I encounter the following error: "Object selected is not a circle or arc." Issue Details: The arc variable is supposed to represent the midpoint of an arc segment in a polyline. The coordinates retrieved from the database contain values formatted with a total of 6 digits (before and after the decimal point combined). Due to this formatting, it seems that AutoCAD does not correctly interpret the arc point as a valid arc or circle entity, causing the _dimradius command to fail. Is this the real problem? And what solution do you suggest? Quote
LanloyLisp Posted March 20 Posted March 20 On 3/20/2025 at 10:25 AM, p7q said: I am working on a routine that processes polylines containing arc segments. The function calculates the midpoint of an arc segment and attempts to use the _dimradius command to add a radius dimension. (setq arcData (BulgetoArc p1 p2 bulge)) (setq center (nth 0 arcData)) (setq radius (nth 3 arcData)) (setq intersection (line-intersection p0 p1 p2 p3)) (setq arc (NearestPointToEntity intersection ent)) (command-s "_.dimradius" arc intersection "") However, I encounter the following error: "Object selected is not a circle or arc." Issue Details: The arc variable is supposed to represent the midpoint of an arc segment in a polyline. The coordinates retrieved from the database contain values formatted with a total of 6 digits (before and after the decimal point combined). Due to this formatting, it seems that AutoCAD does not correctly interpret the arc point as a valid arc or circle entity, causing the _dimradius command to fail. Is this the real problem? And what solution do you suggest? Expand Hi p7q, Probably the arc is congested area, wherein your NearestPointToEntity selects different object or your initial selection is linear. Quote
p7q Posted March 20 Author Posted March 20 On 3/20/2025 at 11:00 AM, LanloyLisp said: Hi p7q, Probably the arc is congested area, wherein your NearestPointToEntity selects different object or your initial selection is linear. Expand I saw with debug that the points is correct but precision is not true . And also it works correctly on some objects. Quote
LanloyLisp Posted March 20 Posted March 20 try (command-s "_.dimradius" intersection intersection "") Quote
Danielm103 Posted March 20 Posted March 20 note I think the default tolerance is comparing points 1.0e-8 comparing vectors 1.0e-6 Quote
p7q Posted March 20 Author Posted March 20 On 3/20/2025 at 2:11 PM, Danielm103 said: note I think the default tolerance is comparing points 1.0e-8 comparing vectors 1.0e-6 Expand How ı chage this tolerance? Quote
Danielm103 Posted March 20 Posted March 20 I don’t know in lisp, In ObjectARX, it can be set with AcGeTol class In Python I use Ge.AutoTol class, I can change the global tolerance, then have it restored import traceback from pyrx import Ap, Db, Ge, Ed @Ap.Command("doit") def function_with_tol(): try: tol = Ge.AutoTol() tol.setEqualPoint(1.0e-6) # do work # tol is restored and the end of the funtion except Exception as err: traceback.print_exception(err) Quote
Tsuky Posted March 21 Posted March 21 This can interest you? (vl-load-com) (defun make_mlead (pt o r obj / ptlst arr nw_obj) (setq ptlst (append pt (polar pt o r)) arr (vlax-make-safearray vlax-vbdouble (cons 0 (- (length ptlst) 1))) ) (vlax-safearray-fill arr ptlst) (setq nw_obj (vla-addMLeader Space (vlax-make-variant arr) 0)) (vla-put-contenttype nw_obj acMTextContent) (vla-put-textstring nw_obj (strcat "{\\fArial|b0|i0|c0|p34;R=" (rtos r 2 2) "\\P\\C1You can put here other value}")) (vla-put-layer nw_obj (getvar "CLAYER")) (vla-put-ArrowheadSize nw_obj (* (getvar "TEXTSIZE") 0.5)) (vla-put-TextHeight nw_obj (getvar "TEXTSIZE")) (if (> (car ptlst) (cadddr ptlst)) (progn (vla-SetDogLegDirection nw_obj 0 (vlax-3D-point '(-1.0 0.0 0.0))) (vla-put-TextJustify nw_obj acAttachmentPointMiddleRight) (vla-setLeaderLineVertices nw_obj 0 (vlax-make-variant arr)) ) (vla-put-TextJustify nw_obj acAttachmentPointMiddleLeft) ) (vla-update nw_obj) ) (defun c:rad2lead ( / ent dxf_ent typ_ent mkv vector vlaobj prm id_rad AcDoc Space ent pt1 pt2 pt x) (while (not (setq ent (entsel "\nSelect a bulge: ")))) (setq typ_ent (cdr (assoc 0 (setq dxf_ent (entget (car ent)))))) (cond ((or (eq typ_ent "ARC") (eq typ_ent "CIRCLE") (eq typ_ent "LWPOLYLINE") (and (eq typ_ent "POLYLINE") (zerop (boole 1 120 (cdr (assoc 70 dxf_ent)))) ) ) (if (or (> (fix (car (trans (cadr ent) 1 0))) 1E6) (> (fix (cadr (trans (cadr ent) 1 0))) 1E6)) (setq mkv T vector (trans (cadr ent) 0 0 T) vlaobj (vlax-ename->vla-object (car ent))) (setq mkv nil) ) (if mkv (vla-move vlaobj (vlax-3d-point (trans (cadr ent) 1 0)) (vlax-3d-point '(0.0 0.0 0.0)))) (setq id_rad (distance '(0 0) (trans (vlax-curve-getsecondderiv (car ent) (setq prm (vlax-curve-getparamatpoint (car ent) (vlax-curve-getclosestpointto (car ent) (if mkv '(0.0 0.0 0.0) (trans (cadr ent) 1 0))) ) ) ) 0 (car ent) T ) ) ) (if mkv (vla-move vlaobj (vlax-3d-point '(0.0 0.0 0.0)) (vlax-3d-point vector))) (cond ((not (zerop id_rad)) (setq AcDoc (vla-get-ActiveDocument (vlax-get-acad-object)) Space (if (= 1 (getvar "CVPORT")) (vla-get-PaperSpace AcDoc) (vla-get-ModelSpace AcDoc) ) ) (vla-startundomark AcDoc) (setq ent (car ent)) (if (member typ_ent '("POLYLINE" "LWPOLYLINE")) (setq pt1 (vlax-curve-getPointAtParam ent (fix prm)) pt2 (vlax-curve-getPointAtParam ent (1+ (fix prm))) pt (vlax-curve-getPointAtParam ent (+ (fix prm) 0.5)) ) (setq pt1 (vlax-curve-getStartPoint ent) pt2 (vlax-curve-getEndPoint ent) pt (vlax-curve-getPointAtDist ent (* 0.5 (- (vlax-curve-getDistAtPoint ent pt2) (vlax-curve-getDistAtPoint ent pt1)))) ) ) (setq x (* (fix (/ (angle (mapcar '* (mapcar '+ pt1 pt2) '(0.5 0.5 0.5)) pt) (* 0.125 pi))) 0.125 pi) x (+ x (rem x (* 0.25 pi))) ) (make_mlead pt x id_rad (vlax-ename->vla-object ent)) (vla-regen AcDoc acactiveviewport) (vla-endundomark AcDoc) ) (T (princ "\nSegment have no bulge.")) ) ) (T (princ "\nThis object can't be availaible for this function!")) ) (prin1) ) Quote
LanloyLisp Posted March 25 Posted March 25 Hi p7q, here are some approach that maybe will work for you. (command-s "_.dimradius" "_non" arc "_non" intersection "") and if the above function doesn't work, try the one below. (setq adoc (vla-get-activedocument (vlax-get-acad-object)) ms (vla-get-modelspace adoc)); insert at start of the program (vlax-invoke ms 'adddimradial center arc 0.); replace line of command-s 1 Quote
p7q Posted March 27 Author Posted March 27 On 3/25/2025 at 3:34 PM, LanloyLisp said: Hi p7q, here are some approach that maybe will work for you. (command-s "_.dimradius" "_non" arc "_non" intersection "") and if the above function doesn't work, try the one below. (setq adoc (vla-get-activedocument (vlax-get-acad-object)) ms (vla-get-modelspace adoc)); insert at start of the program (vlax-invoke ms 'adddimradial center arc 0.); replace line of command-s Expand (command-s "_.dimradius" "_non" arc "_non" intersection "") it's work. Thanks but how work? Can u explane please? Quote
Recommended Posts
Join the conversation
You can post now and register later. If you have an account, sign in now to post with your account.
Note: Your post will require moderator approval before it will be visible.